#include <windows.h>
#include <stdio.h>

#define BUFSIZE 4096
#define VARNAME L"MyVariable"

int wmain(int argc, WCHAR **argv)
{
    DWORD dwRet, dwErr;
    LPTSTR pszOldVal;
	// The path of the child program
    WCHAR szAppName[]=L"C:\\amad\\EnvironVar3\\Debug\\EnvironVar3.exe";
    STARTUPINFO si;
    PROCESS_INFORMATION pi;
    BOOL fExist, fSuccess;
	DWORD Ret;
 
    // Retrieves the current value of the variable if it exists.
    // Sets the variable to a new value, creates a child process,
    // then uses SetEnvironmentVariable to restore the original
    // value or delete it if it did not exist previously 
    pszOldVal = (LPTSTR)malloc(BUFSIZE*sizeof(WCHAR));
    if(pszOldVal == NULL)
    {
        wprintf(L"Out of memory!\n");
        return FALSE;
    }
	else
		wprintf(L"malloc() should be fine!\n");

    dwRet = GetEnvironmentVariable(VARNAME, pszOldVal, BUFSIZE);

    if(dwRet == 0)
    {
        dwErr = GetLastError();
        if(dwErr == ERROR_ENVVAR_NOT_FOUND)
        {
            wprintf(L"The given environment variable does not exist!\n");
            fExist=FALSE;
        }
    }
    else if(BUFSIZE < dwRet)
    {
        pszOldVal = (LPTSTR)realloc(pszOldVal, dwRet*sizeof(WCHAR));   
        if(pszOldVal == NULL)
        {
            wprintf(L"Out of memory!\n");
            return FALSE;
        }

        dwRet = GetEnvironmentVariable(VARNAME, pszOldVal, dwRet);
        if(!dwRet)
        {
            wprintf(L"GetEnvironmentVariable() failed! Error %d\n", GetLastError());
            return FALSE;
        }
        else
		{
			wprintf(L"GetEnvironmentVariable() - The environment variable exists!\n");
			fExist=TRUE;
		}
    }
    else
	{
		wprintf(L"GetEnvironmentVariable() is OK!\n");
		fExist = TRUE;
	}

    // Set a value for the child process to inherit
    if (!SetEnvironmentVariable(VARNAME, L"Test"))
    {
        wprintf(L"SetEnvironmentVariable() failed! Error %d\n", GetLastError());
        return FALSE;
    }
	else
		wprintf(L"SetEnvironmentVariable() is OK! Environment variable was set\n");
 
    // Create a child process
    SecureZeroMemory(&si, sizeof(STARTUPINFO));
    si.cb = sizeof(STARTUPINFO);

    fSuccess = CreateProcess(szAppName, NULL, NULL, NULL, TRUE, 0,
        NULL,     // inherit parent's environment
        NULL, &si, &pi);
    if(!fSuccess)
    {
        wprintf(L"CreateProcess() failed! Error %d\n", GetLastError());
    }
	else
		wprintf(L"CreateProcess() is OK!\n");

    Ret = WaitForSingleObject(pi.hProcess, INFINITE);
	wprintf(L"The WaitForSingleObject() return value is 0X%.8X\n", Ret);

    // Restore the original environment variable 
    if(fExist)
    {
        if(!SetEnvironmentVariable(VARNAME, pszOldVal))
        {
            wprintf(L"SetEnvironmentVariable() failed! Error %d\n", GetLastError());
            return FALSE;
        }
		else
			wprintf(L"SetEnvironmentVariable() - Restoring the old environment variable!\n");
    }
    else
	{
		wprintf(L"SetEnvironmentVariable() - Removing the new environment variable!\n");
		SetEnvironmentVariable(VARNAME, NULL);
	}

    free(pszOldVal);
    return fSuccess;
}
